from database import app

from flask_covid19.blueprints.ecdc.ecdc_service import EcdcService
from flask_covid19.blueprints.owid.owid_service import OwidService
from flask_covid19.blueprints.rki_vaccination.rki_vaccination_service import RkiVaccinationService
from flask_covid19.blueprints.who.who_service import WhoService
from flask_covid19.blueprints.divi.divi_service import DiviService
from flask_covid19.blueprints.rki_cases.rki_service import RkiService


class AllService:
    def __init__(self, who_service: WhoService, owid_service: OwidService, ecdc_service: EcdcService,
                 rki_vaccination_service: RkiVaccinationService, rki_service: RkiService, divi_service: DiviService):
        app.logger.debug("------------------------------------------------------------")
        app.logger.debug(" All Service [init]")
        app.logger.debug("------------------------------------------------------------")
        self.__who_service = who_service
        self.__owid_service = owid_service
        self.__ecdc_service = ecdc_service
        self.__rki_vaccination_service = rki_vaccination_service
        self.__rki_service = rki_service
        self.__divi_service = divi_service
        app.logger.debug("------------------------------------------------------------")
        app.logger.info(" All Service [ready] ")

    def download(self):
        self.__who_service.download()
        self.__owid_service.download()
        self.__ecdc_service.download()
        self.__rki_vaccination_service.download()
        self.__rki_service.download()
        self.__divi_service.download()
        return self

    def import_file(self):
        self.__who_service.import_file()
        self.__owid_service.import_file()
        self.__ecdc_service.import_file()
        self.__rki_vaccination_service.import_file()
        self.__rki_service.import_file()
        return self

    def full_update_dimension_tables(self):
        self.__who_service.full_update_dimension_tables()
        self.__owid_service.full_update_dimension_tables()
        self.__ecdc_service.full_update_dimension_tables()
        self.__rki_vaccination_service.full_update_dimension_tables()
        self.__rki_service.full_update_dimension_tables()
        return self

    def update_dimension_tables(self):
        self.__who_service.update_dimension_tables()
        self.__owid_service.update_dimension_tables()
        self.__ecdc_service.update_dimension_tables()
        self.__rki_vaccination_service.update_dimension_tables()
        self.__rki_service.update_dimension_tables()
        return self

    def full_update_fact_table(self):
        self.__who_service.full_update_fact_table()
        self.__owid_service.full_update_fact_table()
        self.__ecdc_service.full_update_fact_table()
        self.__rki_vaccination_service.full_update_fact_table()
        self.__rki_service.full_update_fact_table()
        return self

    def update_fact_table(self):
        self.__who_service.update_fact_table()
        self.__owid_service.update_fact_table()
        self.__ecdc_service.update_fact_table()
        self.__rki_vaccination_service.update_fact_table()
        self.__rki_service.update_fact_table()
        return self

    def full_update_star_schema(self):
        self.__who_service.full_update_star_schema()
        self.__owid_service.full_update_star_schema()
        self.__ecdc_service.full_update_star_schema()
        self.__rki_vaccination_service.full_update_star_schema()
        self.__rki_service.full_update_star_schema()
        return self

    def update_star_schema(self):
        self.__who_service.update_star_schema()
        self.__owid_service.update_star_schema()
        self.__ecdc_service.update_star_schema()
        self.__rki_vaccination_service.update_star_schema()
        self.__rki_service.update_star_schema()
        return self
