from database import db

from flask_covid19.blueprints.app_admin.app_admin_service import AdminService
from flask_covid19.blueprints.app_all.all_service import AllService
from flask_covid19.blueprints.app_user.user_service import UserService
from flask_covid19.blueprints.ecdc.ecdc_service import EcdcService
from flask_covid19.blueprints.owid.owid_service import OwidService
from flask_covid19.blueprints.rki_vaccination.rki_vaccination_service import RkiVaccinationService
from flask_covid19.blueprints.who.who_service import WhoService
from flask_covid19.blueprints.divi.divi_service import DiviService
from flask_covid19.blueprints.rki_cases.rki_service import RkiService

############################################################################################
#
# Services
#
app_admin_service = AdminService(db)
app_user_service = UserService(db)

who_service = WhoService(db)
owid_service = OwidService(db)
ecdc_service = EcdcService(db)
rki_vaccination_service = RkiVaccinationService(db)
rki_service = RkiService(db)
divi_service = DiviService(db)

all_service = AllService(who_service, owid_service, ecdc_service, rki_vaccination_service, rki_service, divi_service)

db.create_all()
